library IEEE;
use IEEE.std_logic_1164.ALL;
use IEEE.numeric_std.ALL;

entity FDC is
    Port ( C : in std_logic;
           CE : in std_logic;
           D : in std_logic;
           CLR : in std_logic;
           Q : out std_logic);
end fdc;

architecture RTL of FDC is

begin

process (C, CLR)
begin
    if CLR = '1' then
        Q <= '0';
    elsif rising_edge(C) then
        if CE = '1' then
            Q <= D;
        end if;
    end if;
end process;

end RTL;
