library IEEE;
use IEEE.std_logic_1164.ALL;
use IEEE.numeric_std.ALL;

entity FDCP is
    Port ( C : in std_logic;
           CE : in std_logic;
           PRE : in std_logic;
           CLR : in std_logic;
           D : in std_logic;
           Q : out std_logic);
end FDCP;

architecture RTL of fdcp is

begin

process (C, PRE, CLR)
begin
    if PRE = '1' then
        Q <= '1';
    elsif CLR = '1' then
        Q <= '0';
    elsif rising_edge(C) then
        if CE = '1' then
            Q <= D;
        end if;
    end if;
end process;

end RTL;
