library IEEE;
use IEEE.std_logic_1164.ALL;
use IEEE.numeric_std.ALL;

entity FD is
    Port ( C : in std_logic;
           CE: in std_logic;
           D : in std_logic;
           Q : out std_logic);
end FD;

architecture RTL of FD is

begin

process (C)
begin
    if rising_edge(C) then
        if CE = '1' then
            Q <= D;
        end if;
    end if;
end process;

end RTL;

